/* Malloc Debugging Library
 * Function replacement header file.
 * Michael McTernan
 * mm7323@Bris.Ac.Uk
 */

/* Include this file in any source file where you want
 * to monitor the memory usage.
 * 
 * Call the ListUsed() function to get a list of all allocated
 * memory.
 * Call the FreeUsed() function to free all alocated memory.
 */

#include "DbMallocOpts.h"

#ifdef DB_ON

  #define malloc(a)    DbMalloc(a,__FILE__,__LINE__)
  #define calloc(a,b)  DbCalloc(a,b,__FILE__,__LINE__)
  #define strdup(a)    DbStrdup(a,__FILE__,__LINE__)
  #define free(a)      DbFree(a,__FILE__,__LINE__)
  #define realloc(a,b) DbRealloc(a,b,__FILE__,__LINE__)

#endif

void *DbMalloc(size_t Size, char *File, int Line);
void *DbCalloc(size_t Size, size_t Num,char *File, int Line);
char *DbStrdup(char *String, char *File, int Line);
void *DbRealloc(void *OldPtr, size_t NewSize, char *File, int Line);
void  DbFree(void *Mem, char *File, int Line);
void DbListUsed(void);
void DbFreeUsed(void);
